function Xproj = isp_rkopls_phase3(K,fextractor)

% @description
% Extracts Features from data
%
% @function
% Xproj = isp_rkopls_phase3(X,fextractor)
%
% @input
% X: matrix of data to be projected. Each row is a pattern
% fextractor: struct with all parameters for computing features
%             as provided by isp_rkopls_phase2
%
% @output
% Xproj: matrix of features. Each row is a pattern in the new space
%
% @options

% @copyrights Intelligent sound 2006
% @licence GPL?
% @author Jer�nimo Arenas-Garc�a, ISP,IMM,DTU
% @date 29-06-2006
%
% @modified_by XXX
% @modified_date XXX
% @modified_log XXX
%
% @version 1.0
%
% @examples
% Xproj = isp_rkopls_phase3(X,fextractor)

[lx,N1] = size(K);
% X = (X - ones(lx,1)*fextractor.meanX)./(ones(lx,1)*fextractor.std);

n_p = size(fextractor.alpha,2);
Xproj = zeros(lx,n_p);
% R = size(fextractor.centroids,1);
%[R,N]=size(fextractor.centroids);
if isfield(fextractor,'R')
    R=fextractor.R;
    m=randperm(size(K,1));
    Kernel_train=K(m(1:R),:);
    pkk=Kernel_train;
else
    pkk=K;
end

Xproj = pkk' * fextractor.alpha;
% for k = 1:lx
%     pkk=Kernel_train(k,:);
% %     pkk = (exp(-(sum((fextractor.centroids - ones(R,1) * X(k,:)).^2,2))/(2*fextractor.par^2)));
% %     pkk = pkk - fextractor.cent_vector;
%     Xproj(k,:) = pkk' * fextractor.alpha;
% end

