% Finds the closer clusters for generating test kernels
% Inputs:
%       - Xtest      : Original test data. Matrix, N(samples)xF(features).
%       - obj        : Object containg centers and mixing components of the Gaussians (train data).
%
% Outputs:
%       - ID_UL : Partitions data of test data respect to train data.
%       - PP    : Posterior probability of components of test data respect to train data.

function [ID_UL PP]= closerClusterGMM(Xtest,obj)

% Xtest: test data
% C_tot: GMM object containing centers and mixing components of the Gaussians

% Posterior probability of components of test data respect to train data
PP = posterior(obj,Xtest);

%  Partitions data of test data respect to train data
ID_UL = cluster(obj,Xtest);
